picard.sam.markduplicates.util

## Class ReadEnds

- java.lang.Object
- - picard.sam.util.PhysicalLocationInt
  - - picard.sam.util.PhysicalLocationShort
    - - picard.sam.markduplicates.util.ReadEnds

- All Implemented Interfaces:
    PhysicalLocation
  Direct Known Subclasses:
    ReadEndsForMarkDuplicates, ReadEndsForMateCigar

      public abstract class ReadEnds
      extends PhysicalLocationShort

  Little struct-like class to hold read pair (and fragment) end data for duplicate marking.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static byte` | `F`
    `static byte` | `FF`
    `static byte` | `FR`
    `boolean` | `isOpticalDuplicate` A *transient* flag marking this read end as being an optical duplicate.
    `short` | `libraryId`
    `byte` | `orientation`
    `byte` | `orientationForOpticalDuplicates` For optical duplicate detection the orientation matters regard to 1st or 2nd end of a mate
    `static byte` | `R`
    `int` | `read1Coordinate`
    `int` | `read1ReferenceIndex`
    `int` | `read2Coordinate`
    `int` | `read2ReferenceIndex`
    `short` | `readGroup`
    `static byte` | `RF`
    `static byte` | `RR`

    - ### Fields inherited from class picard.sam.util.PhysicalLocationInt

      `tile, x, y`

    - ### Fields inherited from interface picard.sam.util.PhysicalLocation

      `NO_VALUE`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ReadEnds()`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `short` | `getLibraryId()`
    `static byte` | `getOrientationByte(boolean read1NegativeStrand, boolean read2NegativeStrand)` Returns a single byte that encodes the orientation of the two reads in a pair.
    `short` | `getReadGroup()`
    `boolean` | `isPaired()`
    `void` | `setLibraryId(short libraryId)`
    `void` | `setReadGroup(short readGroup)`

    - ### Methods inherited from class picard.sam.util.PhysicalLocationShort

      `setX, setY`

    - ### Methods inherited from class picard.sam.util.PhysicalLocationInt

      `getTile, getX, getY, setTile`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface picard.sam.util.PhysicalLocation

      `hasLocation`

- - ### Field Detail

    - #### F

          public static final byte F

      See Also:
        Constant Field Values

    - #### R

          public static final byte R

      See Also:
        Constant Field Values

    - #### FF

          public static final byte FF

      See Also:
        Constant Field Values

    - #### FR

          public static final byte FR

      See Also:
        Constant Field Values

    - #### RR

          public static final byte RR

      See Also:
        Constant Field Values

    - #### RF

          public static final byte RF

      See Also:
        Constant Field Values

    - #### libraryId

          public short libraryId

    - #### orientation

          public byte orientation

    - #### read1ReferenceIndex

          public int read1ReferenceIndex

    - #### read1Coordinate

          public int read1Coordinate

    - #### read2ReferenceIndex

          public int read2ReferenceIndex

    - #### read2Coordinate

          public int read2Coordinate

    - #### readGroup

          public short readGroup

    - #### orientationForOpticalDuplicates

          public byte orientationForOpticalDuplicates

      For optical duplicate detection the orientation matters regard to 1st or 2nd end of a mate

    - #### isOpticalDuplicate

          public transient boolean isOpticalDuplicate

      A *transient* flag marking this read end as being an optical duplicate.

  - ### Constructor Detail

    - #### ReadEnds

          public ReadEnds()

  - ### Method Detail

    - #### isPaired

          public boolean isPaired()

    - #### getReadGroup

          public short getReadGroup()

      Specified by:
        `getReadGroup` in interface `PhysicalLocation`
      Overrides:
        `getReadGroup` in class `PhysicalLocationInt`

    - #### setReadGroup

          public void setReadGroup(short readGroup)

      Specified by:
        `setReadGroup` in interface `PhysicalLocation`
      Overrides:
        `setReadGroup` in class `PhysicalLocationInt`

    - #### getLibraryId

          public short getLibraryId()

      Specified by:
        `getLibraryId` in interface `PhysicalLocation`
      Overrides:
        `getLibraryId` in class `PhysicalLocationInt`

    - #### setLibraryId

          public void setLibraryId(short libraryId)

      Specified by:
        `setLibraryId` in interface `PhysicalLocation`
      Overrides:
        `setLibraryId` in class `PhysicalLocationInt`

    - #### getOrientationByte

          public static byte getOrientationByte(boolean read1NegativeStrand,
                                                boolean read2NegativeStrand)

      Returns a single byte that encodes the orientation of the two reads in a pair.